<template>
  <v-container>
    <v-row align="center" justify="center">
      <v-col cols="5" justify="center">
        <p>
          Select a <i>preset</i> file, then the desired <i>configuration</i>.
        </p>
        <p>
          Any needed parameter not included in the selected <i>configuration</i> will be asked
          at runtime to the user.
        </p>
        <v-btn text color="primary" :loading="loading" @click="openFolder"
          >Presets <v-icon right>mdi-folder-open</v-icon></v-btn
        >
      </v-col>
      <v-col cols="5">
        <v-select
          v-model="current_preset"
          :items="presets"
          @change="getPreset"
          @click="allPresets"
          label="Preset file"
          prepend-icon="mdi-file"
        ></v-select>
        <v-select
          :disabled="configurations.length <= 0"
          :value="config"
          @input="updateCurrentConfig($event)"
          :items="configurations"
          label="Configuration"
          prepend-icon="mdi-file-tree"
        >
        </v-select>
      </v-col>
    </v-row>
  </v-container>
</template>

<script>
import { experiment } from "@/plugins/experiment.js";

export default {
  name: "Presets",
  props: ["config"],
  data: () => ({
    presets: [],
    configurations: [],
    configurations_dict: {},
    current_preset: null,
    loading: false,
  }),
  methods: {
    updateCurrentConfig(value) {
      this.$emit("update:config", value);
    },
    allPresets() {
      this.updateCurrentConfig(null);
      this.configurations = [];
      this.configurations_dict = {};
      this.current_preset = null;

      this.$axios
        .get("/presets")
        .then((res) => {
          this.presets = res.data.presets;
        })
        .catch((err) => {
          console.log(err);
        });
    },
    getPreset() {
      this.updateCurrentConfig(null);
      this.configurations = [];
      this.configurations_dict = {};

      this.$axios
        .get("/presets", {
          params: {
            preset_name: this.current_preset,
          },
        })
        .then((res) => {
          this.configurations = res.data.configurations;
          this.configurations_dict = res.data.configurations_dict;
        })
        .catch((err) => {
          console.log(err);
        });
    },
    pickPreset() {
      this.$axios
        .post("/presets", {
          get_from_file: true,
          configuration_name: this.config
        })
        .then((res) => {
          let preset_loaded = res.data.result;
          if (preset_loaded) {
            this.$notify.success("Preset loaded!");
            experiment.init(res.data.loops);
          } else {
            this.$notify.error("Error while loading preset");
          }
        })
        .catch(() => {
          this.$notify.error("Error while saving settings");
        });
    },
    openFolder() {
      this.loading = true;
      this.$axios
        .post("/open", {
          is_path: false,
          path: "presets",
        })
        .then(() => {})
        .catch(() => {})
        .finally(() => {
          this.loading = false;
        });
    },
  },
  mounted() {
    this.allPresets();
  },
};
</script>